﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace Blog20121003
{
    class Program
    {
        static void Main(string[] args)
        {
            new Program();
        }
        public Program() {
            int count_page = 0;

            XmlReaderSettings XRS = new XmlReaderSettings();
            XRS.ValidationType = ValidationType.DTD;
            XRS.ProhibitDtd = false;
            XRS.ValidationEventHandler += new System.Xml.Schema.ValidationEventHandler(XRS_ValidationEventHandler);
            XmlReader xtr = XmlReader.Create("http://nowonbun.tistory.com/rss", XRS);
            while (xtr.Read()) {
                if (count_page == 40) {
                    Console.Write("More...");
                    Console.ReadLine();
                    count_page = 0;
                }
                for (int i = 0; i < xtr.Depth; i++) Console.Write(" ");
                switch (xtr.NodeType) { 
                    case XmlNodeType.Element:
                        Console.Write("<" + xtr.Name);
                        if (xtr.AttributeCount > 0) {
                            for (int i = 0; i < xtr.AttributeCount; i++) {
                                xtr.MoveToAttribute(i);
                                Console.Write("{0}={1}", xtr.Name, xtr.Value);
                            }
                        }
                        Console.Write(">");
                        break;
                    case XmlNodeType.Text:
                        Console.WriteLine(xtr.Value);
                        break;
                    case XmlNodeType.EndElement:
                        Console.WriteLine("</" + xtr.Name + ">");
                        break;
                }
                count_page++;
            }
            xtr.Close();

            Console.WriteLine("Press any key...");
            Console.ReadLine();
        }

        void XRS_ValidationEventHandler(object sender, System.Xml.Schema.ValidationEventArgs e)
        {
            if (e.Exception != null) {
                Console.WriteLine("err:{0}, {1}-{2}",e.Exception.Message,e.Exception.LineNumber,e.Exception.LinePosition);
            }
            if (e.Severity == System.Xml.Schema.XmlSeverityType.Error) {
                Console.WriteLine("유효성 검증 에러!!!");
            }
            else if (e.Severity == System.Xml.Schema.XmlSeverityType.Warning) {
                Console.WriteLine("스키마가 존재하지 않음!!!");
            }
        }
    }
}
